Minimum Swaps To Make Sequences Increasing

[leetcode]Minimum Swaps To Make Sequences Increasing

链接:https://leetcode.com/problems/maximum-length-of-repeated-subarray/description/

Question

We have two integer sequences A and B of the same non-zero length.

We are allowed to swap elements A[i] and B[i]. Note that both elements are in the same index position in their respective sequences.

At the end of some number of swaps, A and B are both strictly increasing. (A sequence is strictly increasing if and only if A[0] < A[1] < A[2] < ... < A[A.length - 1].)

Given A and B, return the minimum number of swaps to make both sequences strictly increasing. It is guaranteed that the given input always makes it possible.

Example 1

Input: A = [1,3,5,4], B = [1,2,3,7]
Output: 1
Explanation: 
Swap A[3] and B[3].  Then the sequences are:
A = [1, 3, 5, 7] and B = [1, 2, 3, 4]
which are both strictly increasing.

A, B are arrays with the same length, and that length will be in the range [1, 1000].
A[i], B[i] are integer values in the range [0, 2000].

Solution

class Solution {
public:
  #define inf 0x3fffffff
  int minSwap(vector<int>& A, vector<int>& B) {
    int size = A.size();
    // dp[i][0]表示A[i]和B[i]位置保持不变,dp[i][1]表示A[i]和B[i]位置调换
    vector<vector<int> > dp;
    dp.resize(size);
    for (int i = 0; i < size; i++) dp[i].resize(2, inf);

    dp[0][0] = 0, dp[0][1] = 1;
    for (int i = 1; i < size; i++) {
      // 以下所做是为了保证操作后A[i]>A[i-1]且B[i]>B[i-1]
      if (A[i] > A[i-1] && B[i] > B[i-1]) {
        // 如果i的位置不换,则采用前面没换的
        dp[i][0] = min(dp[i-1][0], dp[i][0]);
        // 如果i的位置换了,则采用前面也换了的
        dp[i][1] = min(dp[i-1][1]+1, dp[i][1]);
      }
      // 这里反过来
      if (A[i] > B[i-1] && B[i] > A[i-1]) {
        // 如果i的位置不换,则采用前面换了的
        dp[i][0] = min(dp[i-1][1], dp[i][0]);
        // 如果i的位置换了,则采用前面没换的
        dp[i][1] = min(dp[i-1][0]+1, dp[i][1]);
      }
    }
    return min(dp[size-1][0], dp[size-1][1]);
  }
};

思路:这道题比较复杂,使用dp[i][0]表示A[i]和B[i]位置保持不变,dp[i][1]表示A[i]和B[i]位置调换。后面保证操作后A[i]>A[i-1]且B[i]>B[i-1],所以出现了两种情况:

  1. A[i] > A[i-1] && B[i] > B[i-1]
  2. A[i] > B[i-1] && B[i] > A[i-1]

对于每一种情况进行分析(具体见代码)。

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值